package com.ab.abwifidemo;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "com.ab.abwifidemo", "com.ab.abwifidemo.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "com.ab.abwifidemo", "com.ab.abwifidemo.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "com.ab.abwifidemo.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static com.AB.ABWifi.ABWifi _wifi = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edittext1 = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 27;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 29;BA.debugLine="Activity.LoadLayout(\"1\")";
mostCurrent._activity.LoadLayout("1",mostCurrent.activityBA);
 //BA.debugLineNum = 31;BA.debugLine="wifi.Initialize(\"wifi\")";
_wifi.Initialize(processBA,"wifi");
 //BA.debugLineNum = 32;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 50;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 52;BA.debugLine="wifi.StopWifi";
_wifi.StopWifi();
 //BA.debugLineNum = 53;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 34;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 36;BA.debugLine="If wifi.StartWifi() Then";
if (_wifi.StartWifi()) { 
 //BA.debugLineNum = 38;BA.debugLine="wifi.GetNewReadingWifi";
_wifi.GetNewReadingWifi();
 };
 //BA.debugLineNum = 40;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 21;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 24;BA.debugLine="Private EditText1 As EditText";
mostCurrent._edittext1 = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 25;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 18;BA.debugLine="Dim wifi As ABWifi";
_wifi = new com.AB.ABWifi.ABWifi();
 //BA.debugLineNum = 19;BA.debugLine="End Sub";
return "";
}
public static String  _wifi_foundreadings(anywheresoftware.b4a.objects.collections.List _readings) throws Exception{
int _i = 0;
String _s = "";
com.AB.ABWifi.ABWifi.ABWifiReading _reading = null;
 //BA.debugLineNum = 55;BA.debugLine="Sub wifi_FoundReadings(readings As List)";
 //BA.debugLineNum = 56;BA.debugLine="Dim i As Int";
_i = 0;
 //BA.debugLineNum = 57;BA.debugLine="Dim s As String";
_s = "";
 //BA.debugLineNum = 58;BA.debugLine="For i = 0 To readings.Size - 1";
{
final int step28 = 1;
final int limit28 = (int) (_readings.getSize()-1);
for (_i = (int) (0); (step28 > 0 && _i <= limit28) || (step28 < 0 && _i >= limit28); _i = ((int)(0 + _i + step28))) {
 //BA.debugLineNum = 59;BA.debugLine="Dim reading As ABWifiReading = readings.Get(i)";
_reading = (com.AB.ABWifi.ABWifi.ABWifiReading)(_readings.Get(_i));
 //BA.debugLineNum = 60;BA.debugLine="Log(\"---------------------------------\")";
anywheresoftware.b4a.keywords.Common.Log("---------------------------------");
 //BA.debugLineNum = 61;BA.debugLine="Log(\"BSSID: \" & reading.BSSID)";
anywheresoftware.b4a.keywords.Common.Log("BSSID: "+_reading.BSSID);
 //BA.debugLineNum = 62;BA.debugLine="Log(\"Level: \" & reading.Level)";
anywheresoftware.b4a.keywords.Common.Log("Level: "+BA.NumberToString(_reading.Level));
 //BA.debugLineNum = 63;BA.debugLine="Log(\"IsConnected: \" & reading.IsConnected)";
anywheresoftware.b4a.keywords.Common.Log("IsConnected: "+BA.ObjectToString(_reading.IsConnected));
 //BA.debugLineNum = 64;BA.debugLine="Log(\"Frequency: \" & reading.Frequency)";
anywheresoftware.b4a.keywords.Common.Log("Frequency: "+BA.NumberToString(_reading.Frequency));
 //BA.debugLineNum = 65;BA.debugLine="Log(\"IsBestSignal: \" & reading.IsBestSignal)";
anywheresoftware.b4a.keywords.Common.Log("IsBestSignal: "+BA.ObjectToString(_reading.IsBestSignal));
 //BA.debugLineNum = 66;BA.debugLine="Log(\"SSID: \" & reading.SSID)";
anywheresoftware.b4a.keywords.Common.Log("SSID: "+_reading.SSID);
 //BA.debugLineNum = 67;BA.debugLine="Log(\"Capabilities: \" & reading.Capabilities)";
anywheresoftware.b4a.keywords.Common.Log("Capabilities: "+_reading.Capabilities);
 //BA.debugLineNum = 69;BA.debugLine="s = s & \"---------------------------------\" & CRLF";
_s = _s+"---------------------------------"+anywheresoftware.b4a.keywords.Common.CRLF;
 //BA.debugLineNum = 70;BA.debugLine="s = s & \"BSSID: \" & reading.BSSID & CRLF";
_s = _s+"BSSID: "+_reading.BSSID+anywheresoftware.b4a.keywords.Common.CRLF;
 //BA.debugLineNum = 71;BA.debugLine="s = s & \"Level: \" & reading.Level & CRLF";
_s = _s+"Level: "+BA.NumberToString(_reading.Level)+anywheresoftware.b4a.keywords.Common.CRLF;
 //BA.debugLineNum = 72;BA.debugLine="s = s & \"IsConnected: \" & reading.IsConnected & CRLF";
_s = _s+"IsConnected: "+BA.ObjectToString(_reading.IsConnected)+anywheresoftware.b4a.keywords.Common.CRLF;
 //BA.debugLineNum = 73;BA.debugLine="s = s & \"Frequency: \" & reading.Frequency & CRLF";
_s = _s+"Frequency: "+BA.NumberToString(_reading.Frequency)+anywheresoftware.b4a.keywords.Common.CRLF;
 //BA.debugLineNum = 74;BA.debugLine="s = s & \"IsBestSignal: \" & reading.IsBestSignal & CRLF";
_s = _s+"IsBestSignal: "+BA.ObjectToString(_reading.IsBestSignal)+anywheresoftware.b4a.keywords.Common.CRLF;
 //BA.debugLineNum = 75;BA.debugLine="s = s & \"SSID: \" & reading.SSID & CRLF";
_s = _s+"SSID: "+_reading.SSID+anywheresoftware.b4a.keywords.Common.CRLF;
 //BA.debugLineNum = 76;BA.debugLine="s = s & \"Capabilities: \" & reading.Capabilities & CRLF";
_s = _s+"Capabilities: "+_reading.Capabilities+anywheresoftware.b4a.keywords.Common.CRLF;
 }
};
 //BA.debugLineNum = 79;BA.debugLine="EditText1.Text = s";
mostCurrent._edittext1.setText((Object)(_s));
 //BA.debugLineNum = 82;BA.debugLine="wifi.GetNewReadingWifi";
_wifi.GetNewReadingWifi();
 //BA.debugLineNum = 83;BA.debugLine="End Sub";
return "";
}
public static String  _wifi_wifienabled(boolean _isenabled) throws Exception{
 //BA.debugLineNum = 42;BA.debugLine="Sub wifi_WifiEnabled(IsEnabled As Boolean)";
 //BA.debugLineNum = 43;BA.debugLine="If IsEnabled Then";
if (_isenabled) { 
 //BA.debugLineNum = 44;BA.debugLine="wifi.GetNewReadingWifi";
_wifi.GetNewReadingWifi();
 }else {
 //BA.debugLineNum = 46;BA.debugLine="ToastMessageShow(\"Failed to enable Wifi\", True)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Failed to enable Wifi",anywheresoftware.b4a.keywords.Common.True);
 };
 //BA.debugLineNum = 48;BA.debugLine="End Sub";
return "";
}
}
